#import "FileReaderPlugin.h"
#import "FilePreviewVC.h"
#if __has_include(<file_reader/file_reader-Swift.h>)
#import <file_reader/file_reader-Swift.h>
#else
// Support project import fallback if the generated compatibility header
// is not copied when this plugin is created as a library.
// https://forums.swift.org/t/swift-static-libraries-dont-copy-generated-objective-c-header/19816
#import "file_reader-Swift.h"
#endif

@implementation FileReaderPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
FlutterMethodChannel* channel = [FlutterMethodChannel
                                   methodChannelWithName:@"file_reader"
                                   binaryMessenger:[registrar messenger]];
    FileReaderPlugin* instance = [[FileReaderPlugin alloc] init];
  instance.hostViewController = [UIApplication sharedApplication].delegate.window.rootViewController;
  NSString *backImgKey = [registrar lookupKeyForAsset:@"assets/images/ic_back.png" fromPackage:@"file_reader"];
  NSString *backImgPath = [[NSBundle mainBundle] pathForResource:backImgKey ofType:nil];
  instance.backImgPath = backImgPath;
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"openFile" isEqualToString:call.method]) {
    NSString *path = call.arguments[@"path"];
    NSString *title = call.arguments[@"title"];
    FilePreviewVC *preview = [[FilePreviewVC alloc] init];
    preview.backImgPath = self.backImgPath;
    preview.url = path;
    preview.title = title != NULL ? title : @"Chi tiet file";
    UINavigationController *navCtrl = [[UINavigationController alloc] initWithRootViewController:preview];
    [self.hostViewController presentViewController:navCtrl animated:YES completion:nil];
  } else {
    result(FlutterMethodNotImplemented);
  }
}
@end
